/*
This file demonstrates two methods of making the tracker directional. Note that
if the tracker is not directional -- i.e., if it is always centered on
the player -- this stuff is all moot! Try compiling the demo without this file included to see
the default behavior.
*/


mob
	player
		var/fullScreen = 1


		verb/full_screen()
			fullScreen = 1
			Method1(tracker, src)


		verb/partial_screen()
			fullScreen = 0
			Method2(tracker, src)


		Move()
			var/oldDir = dir
			. = ..()

			//If direction changes, update tracker accordingly!
			if((oldDir != dir) && tracker)
				if(fullScreen) Method1(tracker, src)
				else Method2(tracker, src)
			else if(.) ummt_ReportMove(src)


proc/Method1(ummt_tracker/tracker, mob/player/M)
	//Method 1: use the full screen and offset the tracker's eye.
	tracker.SetVisibleScreen(1, 1, 11, 11)
	switch(M.dir)
		if(NORTH) tracker.SetEye(M, 0, 30)
		if(SOUTH) tracker.SetEye(M, 0, -30)
		if(EAST) tracker.SetEye(M, 30, 0)
		if(WEST) tracker.SetEye(M, -30, 0)
	ummt_ReportMove(M)


proc/Method2(ummt_tracker/tracker, mob/player/M)
	//Method 2: center tracker's eye on the player, and only enable
	//a portion of the screen.
	tracker.SetEye(M, 0, 0)
	switch(M.dir)
		if(NORTH)
			tracker.SetVisibleScreen(1, 6, 11, 11)
		if(SOUTH)
			tracker.SetVisibleScreen(1, 1, 11, 6)
		if(EAST)
			tracker.SetVisibleScreen(6, 1, 11, 11)
		if(WEST)
			tracker.SetVisibleScreen(1, 1, 6, 11)
	ummt_ReportMove(M)
